//
//  CMRThreadViewerTbDelegate.h
//  BathyScaphe
//
//  Updated by Tsutomu Sawada on 10/09/23.
//  Copyright 2005-2010 BathyScaphe Project. All rights reserved.
//  encoding="UTF-8"
//

#import <Foundation/Foundation.h>
#import "CMRToolbarDelegateImp.h"

@interface CMRThreadViewerTbDelegate : CMRToolbarDelegateImp {
    IBOutlet NSSegmentedControl *m_historyButton;
    IBOutlet NSSegmentedControl *m_scaleButton;
    IBOutlet NSPopUpButton *m_actionButton;
    IBOutlet NSButton *m_thunderButton;
}
@end


@interface CMRThreadViewerTbDelegate(Private)
- (NSString *)reloadThreadItemIdentifier;
- (NSString *)replyItemIdentifier;
- (NSString *)addFavoritesItemIdentifier;
- (NSString *)deleteItemIdentifier;
- (NSString *)toggleOnlineModeIdentifier;

// Available in BathyScaphe 1.0.2 and later.
- (NSString *)stopTaskIdentifier;

// Available in SledgeHammer and later.
- (NSString *)historySegmentedControlIdentifier;
- (NSString *)orderFrontBrowserItemIdentifier;

// Available in ReinforceII and later.
- (NSString *)scaleSegmentedControlIdentifier;

// Reserved
//- (NSString *)actionButtonItemIdentifier;
@end
